<p align="center">
    <img src="https://codewithmukesh.com/wp-content/uploads/2021/08/fullstackhero-banner.jpg" alt="fullstackhero">
<h1 align="center">.NET WebAPI Boilerplate</h1>
</p>

.NET WebAPI Boilerplate Template built with .NET 6.0. Incorporates the most essential Packages your projects will ever need. Follows Clean Architecture Principles.

## About

`dotnet-webapi-boilerplate` is the integral part of the `fullstackhero` project.

`fullstackhero` is a venture to develop industry leading boilerplate templates for the dotnet stack as the backend (webapi) along with modern client frameworks like Angular, MVC and Blazor.

This repository contains the WebApi Project of `fullstackhero`.

## Release Planning

Expected to be released by Novemeber, 2021 as soon as .NET 6 LTS is launched by Microsoft. Preview versions of this project will be available by October 15, 2021 for Initial Developer Testing.

As of August 30, 2021, the .NET WebApi Boilerplate project has made a considerable progress.

Track Progress - [Release 1.0 Milestones](https://github.com/fullstackhero/dotnet-webapi-boilerplate/milestone/1)

Participate in Discussions - [QNA & General Discussions](https://github.com/fullstackhero/dotnet-webapi-boilerplate/discussions)

Join our Discord - [fullstackhero @ Discord](https://discord.gg/gdgHRt4mMw)

## Features

- [x] Built on .NET 6.0
- [x] Follows Clean Architecture Principles
- [ ] Completely Documented at [fullstackhero.net](https://fullstackhero.net)
- [x] Multi Tenancy Support
- [x] Supports MySQL, MSSQL & PostgreSQL!
- [x] Uses Entity Framework Core as DB Abstraction
- [x] Flexible Repository Pattern
- [x] Dapper Integration for Optimal Performance
- [x] Serilog Integration
- [x] Swagger Support
- [x] Mapster
- [x] API Versioning
- [x] Response Caching - Distributed Caching
- [x] Fluent Validations
- [x] Audit Logging
- [ ] Advanced User & Role Based Permission Management
- [x] Code Analysis & StyleCop Integration with Rulesets
- [x] JSON Based Localization with Caching
- [x] Hangfire Support
- [x] File Storage Service
- [ ] Test Projects
- [ ] & Much More

## Developer's Guide

## Prerequisites
1. Visual Code v1.59.xx or higher / Visual Studio 2022 Preview (17.0.0 Preview 4.0) or Higher.
2. dotnet-sdk-6.0.100-rc.1.21458.32 or higher.
3. PostgreSQL / MSSQL / MySQL Database Server instances.

## Community

- Discord [@fullstackhero](https://discord.gg/gdgHRt4mMw)

## License

This project is licensed with the [MIT license](LICENSE).
